## oasys 1.4.0maemo-diablo2

=== debian/changelog ===
oasys (1.4.0maemo-diablo2) diablo; urgency=low

  * 1.4.0maemo-diablo2 Porting of oasys libraries for Maemo 4.1.x codename Diablo fron version 1.4.0ubuntu2

 -- Francesco Baldassarri <francesc.baldassarr2@studio.unibo.it>  Wed, 26 May 2010 00:08:12 +0100

oasys (1.4.0ubuntu2) karmic; urgency=low

  * Applying fix-aclocal-oasys.patch to fix configuring fail for applications
    depend on oasys (Bug: #2998095)
  * Applying fix-amd64-build-fail.patch to fix building fail on amd64
    (Bug: #2990587)
  * debian/rules:
    - added quilt support
    - added dh_makeshlibs in binary_arch
    - run ./build-configure.sh to regenerate configure templates (Bug: #2990587)
  * debian/control:
    - replaced '[]' in '<>' at maintainer email
    - removed make, gcc, g++ as Build-Depends
    - added quilt as Build-Depends
    - added autoconf as Build-Depends in order to run ./build-confugure.sh
    - added Standards-Version 3.8.4

 -- Leo Iannacone <l3on@ubuntu.com>  Tue, 25 May 2010 12:21:52 +0200

oasys (1.4.0maemo-diablo1) diablo; urgency=low

  * 1.4.0maemo-diablo1 Porting of oasys libraries for Maemo 4.1.x codename Diablo fron version 1.4.0ubuntu1

 -- Francesco Baldassarri <francesc.baldassarr2@studio.unibo.it>  Wed, 12 May 2010 02:10:54 +0100

oasys (1.4.0ubuntu1) karmic; urgency=low

  * Applying fix-aclocal-oasys.patch to fix configuring fail for applications
    depend on oasys (Bug: #2998095)
  * Applying fix-amd64-build-fail.patch to fix building fail on amd64
    (Bug: #2990587)
  * debian/rules:
    - added quilt support
    - run ./build-configure.sh to regenerate configure templates (Bug: #2990587)
  * debian/control:
    - replaced '[]' in '<>' at maintainer email
    - removed make, gcc, g++ as Build-Depends
    - added quilt as Build-Depends
    - added autoconf as Build-Depends in order to run ./build-confugure.sh
    - added Standards-Version 3.8.4

 -- Leo Iannacone <l3on@ubuntu.com>  Fri, 07 May 2010 19:41:13 +0200

oasys (1.4.0) unstable; urgency=low

  * 1.4.0 build 

 -- Alex McMahon <alex.mcmahon@cs.tcd.ie>  Fri, 22 Feb 2010 16:46:17 +0100

oasys (1.3.0) unstable; urgency=low

  * 2.6.0 build 2.6.0 build 

 -- Alex McMahon <alex.mcmahon@cs.tcd.ie>  Fri, 08 May 2009 16:46:17 +0100

oasys (1.3.0-2) unstable; urgency=low

  * tweak autoconf and build rules* 

 -- Michael Demmer <demmer@sandbox.berkeley.intel-research.net>  Wed,  5 Mar 2008 14:38:24 -0800

oasys (1.3.0-1) unstable; urgency=low

  * Initial release of a debian package.

 -- Michael Demmer <demmer@cs.berkeley.edu>  Wed,  5 Mar 2008 11:28:10 -0800
