=== debian/changelog ===
oasys (1.4.0maemo-fremantle2) fremantle; urgency=low

  * 1.4.0maemo-fremantle2 Porting of oasys libraries for Maemo 5 codename Fremantle fron version 1.4.0ubuntu2

 -- Francesco Baldassarri <francesc.baldassarr2@studio.unibo.it>  Wed, 26 May 2010 00:08:12 +0100

oasys (1.4.0maemo-fremantle1) fremantle; urgency=low

  * 1.4.0maemo-fremantle1 Porting of oasys libraries for Maemo 5 codename Fremantle fron version 1.4.0ubuntu1

 -- Francesco Baldassarri <francesc.baldassarr2@studio.unibo.it>  Wed, 12 May 2010 02:10:54 +0100
