=== debian/control ===
Source: oasys
Section: libs
Priority: optional
Maintainer: Francesco Baldassarri <francesc.baldassarr2@studio.unibo.it>
XSBC-Original-Maintainer: Leo Iannacone <l3on@ubuntu.com>
Build-Depends: debhelper (>= 5), tcl8.5-dev, libdb4.2-dev, libxerces27-dev, quilt, autoconf
Standards-Version: 3.7.2

Package: liboasys
Architecture: any
Depends: ${shlibs:Depends}
Description: The oasys library
 .
 Oasys is a C++ utility library of system wrappers and utility classes.

Package: liboasys-dev
Architecture: any
Section: libdevel
Depends: liboasys (= ${Source-Version})
Description: The oasys library - development headers
 .
 Oasys is a C++ utility library of system wrappers and utility
 classes. This package contains the development headers.
